SystemOrganization addCategory: #'Xpf-Server-Models'!
SystemOrganization addCategory: #'Xpf-Server-Rest'!
SystemOrganization addCategory: #'Xpf-Server'!
SystemOrganization addCategory: #'Xpf-Server-Rfb'!

RestHttpHandler subclass: #XpfRestFeedbackHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!

!XpfRestFeedbackHttpHandler class methodsFor: 'handling' stamp: 'cs 5/19/2009 15:31'!
canBeAutostarted

	^ true! !

!XpfRestFeedbackHttpHandler class methodsFor: 'handling' stamp: 'cs 5/20/2009 16:43'!
pathPattern

	^ super pathPattern , 'feedback'! !

!XpfRestFeedbackHttpHandler methodsFor: 'authentication' stamp: 'SR 4/15/2009 14:23'!
needsAuthentication

	^ false! !

!XpfRestFeedbackHttpHandler methodsFor: 'request processing' stamp: 'SR 4/15/2009 14:38'!
process: anHTTPRequest
	"Handles an http request. Should answer with an http response."
	
	^ HTTPResponse ok entity:''! !

RestHttpHandler subclass: #XpfRestInfoHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!

!XpfRestInfoHttpHandler class methodsFor: 'handling' stamp: 'cs 5/19/2009 15:31'!
canBeAutostarted

	^ true! !

!XpfRestInfoHttpHandler class methodsFor: 'handling' stamp: 'cs 5/20/2009 16:43'!
pathPattern

	^ super pathPattern , 'info'! !

!XpfRestInfoHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 17:46'!
realm

	^ 'XPForums'! !

!XpfRestInfoHttpHandler methodsFor: 'testing' stamp: 'topa 5/20/2009 14:53'!
isAuthenticated: anHeaderField

	^ (XpfUser authenticate: anHeaderField userid by: anHeaderField password) notNil
	! !

!XpfRestInfoHttpHandler methodsFor: 'authentication' stamp: 'mig 4/1/2009 15:19'!
needsAuthentication

	^ true! !

!XpfRestInfoHttpHandler methodsFor: 'request processing' stamp: 'SR 3/9/2009 16:04'!
process: anHTTPRequest
	"Handles an http request. Should answer with an http response."
	
	^ (super process: anHTTPRequest) ifNil: [ | user |
		user := XpfUser findByLogin: (anHTTPRequest headers fieldNamed: 'AUTHORIZATION') userid.
		
		HTTPResponse ok entity: (
			(XpfRestResourceHttpHandler uriMapping at: user class) value: user).
	]
! !

RestHttpHandler subclass: #XpfRfbTunnelHttpHandler
	instanceVariableNames: ''
	classVariableNames: 'AssignedPorts'
	poolDictionaries: ''
	category: 'Xpf-Server-Rfb'!

XpfRfbTunnelHttpHandler class
	instanceVariableNames: 'assignedPorts pendingTime'!

XpfRfbTunnelHttpHandler class
	instanceVariableNames: 'assignedPorts pendingTime'!

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'bs 5/5/2009 16:52'!
assignAvailablePortTo: aUserId

	| aPortNumber |
	self freePorts.
	aPortNumber := self portAssignedTo: aUserId.
	aPortNumber ifNil: [
		aPortNumber := self nextAvailablePort.
		self assignedPorts at: aPortNumber put: {aUserId. TimeStamp now}].
	^ aPortNumber! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 10:53'!
assignedPorts

	^ assignedPorts! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 10:54'!
assignedPorts: anObject

	assignedPorts := anObject.! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'cs 5/19/2009 15:31'!
canBeAutostarted

	^ true! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 10:55'!
firstPort

	^ 14000! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'bs 5/5/2009 18:01'!
freePorts

	| timeOfRequest isPending |
	self assignedPorts keys do: [:port |
		timeOfRequest := (self assignedPorts at: port) at: 2.
		isPending := (TimeStamp now - timeOfRequest) <= self pendingTime.
		isPending ifFalse: [
			[(SpSocket connectToServerOnHost: 'localhost' port: port) close] 
			on: Error do: [:ignore | self assignedPorts removeKey: port]]].! !

!XpfRfbTunnelHttpHandler class methodsFor: 'initialization' stamp: 'topa 4/27/2009 11:05'!
initialize

	"XpfRfbTunnelHttpHandler initialize"
	self 
		pendingTime: (Duration minutes: 5);
		assignedPorts: Dictionary new.! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 11:05'!
nextAvailablePort

	| next |
	next := self firstPort.
	self assignedPorts keys do: [:port | (next == port) ifTrue: [next := next + 1]].
	^ next! !

!XpfRfbTunnelHttpHandler class methodsFor: 'handling' stamp: 'cs 5/20/2009 16:43'!
pathPattern

	^ super pathPattern , 'rfb'! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 10:58'!
pendingTime

	^ pendingTime! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 10:58'!
pendingTime: aDuration

	pendingTime := aDuration.! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 4/27/2009 11:05'!
portAssignedTo: aUserId

	| portUserAssoc |
	portUserAssoc := self assignedPorts associations 
		detect: [:anAssoc | anAssoc value first = aUserId] ifNone: [nil].
	^ portUserAssoc ifNotNil: [portUserAssoc key].! !

!XpfRfbTunnelHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 17:46'!
realm

	^ 'XPForums'! !

!XpfRfbTunnelHttpHandler methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 14:56'!
isAuthenticated: anHeaderField

	^ (XpfUser authenticate: anHeaderField userid by: anHeaderField password) notNil
	! !

!XpfRfbTunnelHttpHandler methodsFor: 'as yet unclassified' stamp: 'bs 4/17/2009 15:53'!
needsAuthentication

	^ true! !

!XpfRfbTunnelHttpHandler methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 17:48'!
process: anHTTPRequest
	"Handles an http request. Should answer with an http response."
	
	| aPortNumber userId |

	userId := (anHTTPRequest headers fieldNamed: 'AUTHORIZATION') userid.
	aPortNumber := self class assignAvailablePortTo: userId.
	^ HTTPResponse ok entity: aPortNumber asString
! !

!Object methodsFor: '*xpf-server-models' stamp: 'mfp 3/6/2009 11:45'!
isXpfEntity
	^ false! !

Object subclass: #XpfEntityRevisionWrapper
	instanceVariableNames: 'clientRevision entity restUri isValid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:17'!
clientRevision

	^ clientRevision! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:17'!
clientRevision: anObject

	clientRevision := anObject.! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:17'!
entity

	^ entity! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:17'!
entity: anObject

	entity := anObject.! !

!XpfEntityRevisionWrapper methodsFor: 'as yet unclassified' stamp: 'mt 4/21/2009 13:18'!
initialize

	super initialize.
	self isValid: true.! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mt 4/21/2009 13:15'!
isValid

	^ isValid! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mt 4/21/2009 13:15'!
isValid: anObject 

	isValid := anObject.! !

!XpfEntityRevisionWrapper methodsFor: 'testing' stamp: 'cs 5/15/2009 14:24'!
needsUpdate

	^ self entity isNil
		or: [self isValid not
		or: [self entity revision > self clientRevision]]! !

!XpfEntityRevisionWrapper methodsFor: 'resolving' stamp: 'mt 4/21/2009 15:30'!
resolve: anHTTPRequest handler: handler

	[self entity:
		(self resolveUri: self restUri request: anHTTPRequest handler: handler)]
		on: RestError
		do: [:e | self isValid: false. ^ self].
	self entity isCollection ifTrue:
		[self entity:
			(self resolveUri: self shortRestUri request: anHTTPRequest handler: handler)]! !

!XpfEntityRevisionWrapper methodsFor: 'request processing' stamp: 'mig 4/1/2009 18:08'!
resolveUri: aString request: anHTTPRequest handler: handler

	^ aString isEmpty
		ifTrue: []
		ifFalse: [RestRequestProcessor new
			handler: handler;
			request: anHTTPRequest;
			resolveUri: aString]
! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:17'!
restUri

	^ restUri! !

!XpfEntityRevisionWrapper methodsFor: 'accessing' stamp: 'mig 4/1/2009 17:18'!
restUri: anObject

	restUri := anObject.! !

!XpfEntityRevisionWrapper methodsFor: 'resolving' stamp: 'mig 4/1/2009 17:55'!
shortRestUri

	| result |
	result := String new.
	(self restUri findTokens: $/) allButLast
		do: [:each | result := result, each]
		separatedBy: [result := result, '/'].
	^ result! !

RestResourceHttpHandler subclass: #XpfRestResourceHttpHandler
	instanceVariableNames: ''
	classVariableNames: 'ObsoleteRestUriTable'
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!

XpfRestResourceHttpHandler subclass: #XpfRestChangesHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!

!XpfRestChangesHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 19:18'!
pathPattern

	^ 'changes'! !

!XpfRestChangesHttpHandler methodsFor: 'request processing' stamp: 'mt 4/21/2009 13:11'!
findChanges: anHTTPRequest

	| wrapper result |
	result := OrderedCollection new.
	(self postDataFor: anHTTPRequest) keysAndValuesDo:	[ :restUri :revision | 
		wrapper := XpfEntityRevisionWrapper new
			restUri: restUri;
			clientRevision: revision;
			resolve: anHTTPRequest handler: self.
			wrapper needsUpdate ifTrue: [ result add: wrapper restUri ]].
	^ self responseFor: result! !

!XpfRestChangesHttpHandler methodsFor: 'request processing' stamp: 'mig 4/1/2009 15:53'!
postDataFor: anHTTPRequest

	 | data |
	anHTTPRequest class category = 'Hyper' ifFalse: [anHTTPRequest ensureFullRead].
	data := Json readFrom: anHTTPRequest entityBody value readStream.
	^ data! !

!XpfRestChangesHttpHandler methodsFor: 'request processing' stamp: 'topa 5/20/2009 16:42'!
process: anHTTPRequest

	^ anHTTPRequest isPost 
		ifFalse: [HTTPResponse badRequest]
		ifTrue: [
			self setOnlineFromRequest: anHTTPRequest.
			self findChanges: anHTTPRequest]! !

!XpfRestChangesHttpHandler methodsFor: 'request processing' stamp: 'mig 4/1/2009 15:46'!
responseFor: aCollection

	^ HTTPResponse ok entity: (Json render: aCollection)! !

!XpfRestChangesHttpHandler methodsFor: 'request processing' stamp: 'topa 5/20/2009 14:43'!
setOnlineFromRequest: anHTTPRequest
	
	(self userFromRequest: anHTTPRequest)
		ifNotNilDo: [:user| user
			lastAccess: TimeStamp now;
			wasOnline: true].! !

!XpfRestResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:38'!
canBeAutostarted

	^ true! !

!XpfRestResourceHttpHandler class methodsFor: 'redirecting' stamp: 'mt 4/21/2009 18:23'!
lookupObsoleteRestUri: aString

	ObsoleteRestUriTable ifNil: [ObsoleteRestUriTable := Dictionary new].
	^   ObsoleteRestUriTable at: aString ifAbsent: [].! !

!XpfRestResourceHttpHandler class methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 17:46'!
realm

	^ 'XPForums'! !

!XpfRestResourceHttpHandler class methodsFor: 'redirecting' stamp: 'cs 5/22/2009 13:55'!
redirectRestUriFrom: sourceUriString to: targetUriString

	ObsoleteRestUriTable ifNil: [ObsoleteRestUriTable := Dictionary new].
	ObsoleteRestUriTable
	 	at: self pathPattern, sourceUriString put: self pathPattern, targetUriString;
		removeKey: self pathPattern, targetUriString ifAbsent: [].! !

!XpfRestResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 5/22/2009 14:00'!
rootResources

	^ Dictionary
		with: 'projects' -> XpfProject
		with: 'users' -> XpfUser! !

!XpfRestResourceHttpHandler class methodsFor: 'resources' stamp: 'cs 4/17/2009 12:01'!
uriMapping

	^ Dictionary newFrom:{
		XpfUser -> [:user| '/users/{1}' format: {user id}].		
		XpfProject -> [:project| '/projects/{1}' format: {project id}].
		XpfIteration -> [:iter | '{1}/iterations/{2}' format: {iter project restUri. iter id}].
		XpfFutureIteration -> [:iter | '{1}/iterations/{2}' format: {iter project restUri. iter id}].			
		XpfUserStory -> [:us | '{1}/userStories/{2}' format: {us iteration restUri. us id}].
		XpfTask -> [:task | '{1}/tasks/{2}' format: {task userStory restUri. task id}].		
		XpfHistoryEntry -> [:hist | '{1}/history/{2}' format: {hist entity restUri. hist id}].}
! !

!XpfRestResourceHttpHandler methodsFor: 'testing' stamp: 'topa 5/20/2009 14:52'!
isAuthenticated: anHeaderField

	^ (XpfUser authenticate: anHeaderField userid by: anHeaderField password) notNil
	! !

!XpfRestResourceHttpHandler methodsFor: 'authentication' stamp: 'topa 3/5/2009 13:45'!
needsAuthentication

	^ true! !

!XpfRestResourceHttpHandler methodsFor: 'request processing' stamp: 'topa 5/20/2009 20:25'!
process: anHTTPRequest

	XpfCurrentUser 
		use: (self userFromRequest: anHTTPRequest)
		during: [
			^ [super process: anHTTPRequest]
				on: RestResolveError
				do: [:error | self processForNotFound: anHTTPRequest previousResult: error]]! !

!XpfRestResourceHttpHandler methodsFor: 'request processing' stamp: 'topa 5/20/2009 16:51'!
processForNotFound: anHTTPRequest previousResult: result

	^ (self class lookupObsoleteRestUri: anHTTPRequest uriString)
			ifNil: [result]
			ifNotNilDo: [:restUri |
				HTTPResponse redirectLink addHeaderName: 'location' value: restUri; yourself]! !

!XpfRestResourceHttpHandler methodsFor: 'authentication' stamp: 'topa 5/20/2009 14:47'!
requestAllowed: aRequest for: anObject

	| user |
	(user := self userFromRequest: aRequest) isAdmin ifFalse: [
		(anObject isXpfEntity and: 
		[(anObject isMethod: aRequest class methodName allowedFor: user) not])
			ifTrue: [RestNotAllowedError signal: 'Access forbidden for this resource']].! !

!XpfRestResourceHttpHandler methodsFor: 'authentication' stamp: 'topa 5/20/2009 14:47'!
selectorAllowed: aSelector for: anXpfEntity

	^ (super selectorAllowed: aSelector for: anXpfEntity) or:
		[(anXpfEntity class collectionPropertyNames collect: [:name | 
			(name asString, 'WithDeleted') asSymbol]) includes: aSelector]! !

!XpfRestResourceHttpHandler methodsFor: 'authentication' stamp: 'topa 5/20/2009 14:14'!
userFromRequest: aRequest

	| headerField |
	headerField := aRequest headers 
		fieldNamed: 'AUTHORIZATION' 
		ifNone: [RestNotAllowedError signal: 'No authorization information supplied.'].
		
	^ (XpfUser authenticate: headerField userid by: headerField password)
		ifNil: [RestNotAllowedError signal: 'Username and password does not match.']! !

!Collection methodsFor: '*xpf-server' stamp: 'cs 2/19/2009 14:07'!
add: anObject ifPresent: aBlock
	"Add an object if it is absent. Else run the block"

	(self includes: anObject) 
		ifFalse: [^ self add: anObject]
		ifTrue: [^ aBlock value]! !

RestEntity subclass: #XpfEntity
	instanceVariableNames: 'revision isDeleted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfEntity commentStamp: 'mt 2/12/2009 12:20' prior: 0!
I am the abstract superclass of all entities in the system. These entities could be user stories, tasks, developers, themes, ...!

!XpfEntity class methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:25'!
handlerClass

	^ XpfRestResourceHttpHandler! !

!XpfEntity class methodsFor: 'description' stamp: 'mt 5/7/2009 10:21'!
primitivePropertyNames

	^ super primitivePropertyNames, #(revision isDeleted updateInterval)! !

!XpfEntity methodsFor: 'deleting' stamp: 'test 4/21/2009 14:25'!
delete

	self pvtIsDeleted: true.! !

!XpfEntity methodsFor: 'revisions' stamp: 'topa 4/2/2009 18:42'!
incrementRevision

	self pvtRevision: self revision + 1.! !

!XpfEntity methodsFor: 'testing' stamp: 'mt 4/21/2009 13:58'!
isDeleted

	^ self pvtIsDeleted! !

!XpfEntity methodsFor: 'deleting' stamp: 'mt 4/21/2009 14:17'!
isDeleted: aBoolean
	"Read-only."
	
	^ self! !

!XpfEntity methodsFor: 'authorization' stamp: 'topa 4/7/2009 14:08'!
isMethod: aMethodString allowedFor: aUser
	"returns whether the method is allowed for the specified user; may be overwritten in subclasses"

	^ true! !

!XpfEntity methodsFor: 'testing' stamp: 'topa 3/24/2009 17:27'!
isXpfEntity

	^ true! !

!XpfEntity methodsFor: 'private' stamp: 'mt 4/21/2009 13:55'!
pvtIsDeleted

	^ isDeleted ifNil: [false]! !

!XpfEntity methodsFor: 'private' stamp: 'mt 4/21/2009 13:55'!
pvtIsDeleted: aBoolean

	isDeleted := aBoolean.! !

!XpfEntity methodsFor: 'private' stamp: 'topa 4/2/2009 18:42'!
pvtRevision: aNumber

	revision := aNumber.! !

!XpfEntity methodsFor: 'printing' stamp: 'mt 5/6/2009 16:12'!
responseDepth: depth
	"Returns a Dictionary with the properties. If the properties are entities and the depth is higher than 1 then resolve recursivly."

	| result |
	result := super responseDepth: depth.
	depth = 0 ifTrue: [^ result].
	result addAll: (Dictionary newFrom: 
		(self class collectionPropertyNames collect: [:aSymbol | 
			self responseCollection: aSymbol, 'WithDeleted' depth: depth - 1])).
	^ result! !

!XpfEntity methodsFor: 'accessing' stamp: 'topa 4/2/2009 18:42'!
revision

	^ revision ifNil: [revision := 1]! !

!XpfEntity methodsFor: 'accessing' stamp: 'mt 4/6/2009 16:51'!
revision: anObject
	"rest and GemStone compatibility:"

	^ self! !

!XpfEntity methodsFor: 'updating' stamp: 'mt 5/7/2009 10:17'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	^ 0 "Never."! !

!XpfEntity methodsFor: 'updating' stamp: 'mt 5/7/2009 10:23'!
updateInterval: aNumber
	"readonly"
	
	^ self! !

XpfEntity subclass: #XpfEntityWithHistory
	instanceVariableNames: 'history'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfEntityWithHistory class methodsFor: 'description' stamp: 'cs 4/17/2009 11:56'!
collectionPropertyNames

	^ super collectionPropertyNames, #(history)! !

!XpfEntityWithHistory class methodsFor: 'description' stamp: 'cs 4/17/2009 11:48'!
historyActionNames

	^ #(created changed deleted added removed)! !

!XpfEntityWithHistory methodsFor: 'deleting' stamp: 'cs 4/17/2009 11:40'!
delete

	super delete.
	self historyAddEntry: #deleted.! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 11:36'!
history

	history ifNil: [history := OrderedCollection new].
	^ history! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 11:37'!
history: anObject
	"History is read-only."

	^ self
	! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 11:37'!
historyAddEntry: action

	self historyAddEntry: action for: nil.! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 11:37'!
historyAddEntry: action for: property

	self historyAddEntry: action for: property to: nil.! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 12:02'!
historyAddEntry: action for: property from: oldValue to: newValue
	"Add entry to entity's history."
	
	self history add:
		(XpfHistoryEntry
			entity: self
			action: action
			property: property
			from: oldValue
			to: newValue).
	self incrementRevision.! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 11:37'!
historyAddEntry: action for: property to: newValue

	self historyAddEntry: action for: property from: nil to: newValue.! !

!XpfEntityWithHistory methodsFor: 'history' stamp: 'cs 4/17/2009 12:08'!
historyWithDeleted

	^ self history! !

!XpfEntityWithHistory methodsFor: 'initialize-release' stamp: 'cs 4/17/2009 11:40'!
initialize

	super initialize.
	self historyAddEntry: #created.! !

XpfEntityWithHistory subclass: #XpfIteration
	instanceVariableNames: 'project title userStories timeIdeal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

XpfIteration subclass: #XpfFutureIteration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfFutureIteration methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:18'!
id

	^ -1! !

!XpfFutureIteration methodsFor: 'testing' stamp: 'topa 3/24/2009 17:18'!
isXpfFutureIteration

	^ true! !

!XpfFutureIteration methodsFor: 'as yet unclassified' stamp: 'topa 4/7/2009 14:12'!
moveNilUserStoriesToFuture
	
	self project userStories do: [:us | 
		us iteration ifNil: [self addUserStory: us]].! !

!XpfFutureIteration methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:15'!
timeIdeal

	^ 0! !

!XpfFutureIteration methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:15'!
timeIdeal: anObject

	^ self! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'mfp 4/28/2009 11:50'!
title

	^ 'Open Stories'! !

!XpfFutureIteration methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:14'!
title: aString
	"rest and GemStone compatibility"
	
	^ self! !

!XpfIteration class methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 11:33'!
collectionPropertyNames

	^ super collectionPropertyNames, #(userStories)! !

!XpfIteration class methodsFor: 'as yet unclassified' stamp: 'SR 3/25/2009 18:13'!
newFrom: aDictionary

	^ self new title: (aDictionary at: 'title' ifAbsent: [])! !

!XpfIteration class methodsFor: 'as yet unclassified' stamp: 'SR 4/12/2009 21:15'!
primitivePropertyNames

	^ super primitivePropertyNames, #(title isXpfFutureIteration timeIdeal)! !

!XpfIteration class methodsFor: 'as yet unclassified' stamp: 'SR 4/7/2009 11:33'!
referencePropertyNames

	^ super referencePropertyNames, #(project)! !

!XpfIteration methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:15'!
addNewUserStory: aDictionary

	^ self addUserStory: (XpfUserStory newFrom: aDictionary)! !

!XpfIteration methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:04'!
addUserStory: aUserStory

	| oldTaskRestUris oldUserStoryRestUri |
	aUserStory id ifNil: [aUserStory id: aUserStory class incrementId].
	aUserStory iteration ifNotNil: 
		[oldUserStoryRestUri := aUserStory restUri.
		oldTaskRestUris := aUserStory tasks collect: [:task | task restUri].
		aUserStory iteration removeUserStory: aUserStory].
	aUserStory iteration: self.
	(self pvtUserStories includes: aUserStory) ifFalse: 
		[self pvtUserStories add: aUserStory.
		self 
			historyAddEntry: #added
			for: #userStories
			to: aUserStory.
		oldUserStoryRestUri ifNotNil: 
			[XpfRestResourceHttpHandler 
				redirectRestUriFrom: oldUserStoryRestUri
				to: aUserStory restUri.
			oldTaskRestUris withIndexDo: 
				[:uri :index | 
				XpfRestResourceHttpHandler 
					redirectRestUriFrom: uri
					to: (aUserStory tasks at: index) restUri]]].
	^ aUserStory! !

!XpfIteration methodsFor: 'add-remove' stamp: 'mt 4/16/2009 12:55'!
delete

	self userStories do: [:us | us delete].
	self project historyAddEntry: #removed for: #iterations to: self.
	super delete.
	! !

!XpfIteration methodsFor: 'initialization' stamp: 'mt 4/16/2009 11:09'!
initialize

	super initialize.
	self pvtUserStories: OrderedCollection new.! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/7/2009 11:15'!
isXpfFutureIteration

	^ false! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:11'!
isXpfFutureIteration: aBoolean
	"rest and GemStone compatibility"
	
	^ self! !

!XpfIteration methodsFor: 'printing' stamp: 'SR 3/20/2009 20:56'!
printString

	^ self title ifNil: ['No Title']! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/7/2009 11:15'!
project

	^ project! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:11'!
project: anObject

	self incrementRevision.
	project := anObject.! !

!XpfIteration methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:59'!
pvtUserStories

	^ userStories! !

!XpfIteration methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:59'!
pvtUserStories: anObject

	userStories := anObject.! !

!XpfIteration methodsFor: 'private' stamp: 'cs 5/20/2009 14:03'!
removeUserStory: aUserStory 

	(self userStories noneSatisfy: [:us | us = aUserStory]) ifTrue: [^ aUserStory].
	self pvtUserStories remove: aUserStory.
	self 
		historyAddEntry: #removed
		for: #userStories
		to: aUserStory.
	aUserStory iteration: nil.
	^ aUserStory! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal

	^ timeIdeal! !

!XpfIteration methodsFor: 'accessing' stamp: 'SR 4/12/2009 21:15'!
timeIdeal: anObject

	timeIdeal := anObject! !

!XpfIteration methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:21'!
title

	^ title! !

!XpfIteration methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:26'!
title: anObject

	anObject = self title ifTrue: [^ self].
	self historyAddEntry: #changed for: #title from: self title to: anObject.
	title := anObject.! !

!XpfIteration methodsFor: 'updating' stamp: 'mt 5/7/2009 10:21'!
updateInterval

	^ 3! !

!XpfIteration methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:59'!
userStories

	^ userStories reject: [:us | us isDeleted]! !

!XpfIteration methodsFor: 'accessing' stamp: 'mt 5/6/2009 13:05'!
userStoriesWithDeleted

	^ userStories! !

XpfEntityWithHistory subclass: #XpfProject
	instanceVariableNames: 'title developers iterations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

XpfProject class
	instanceVariableNames: 'projects testProjects useTestData'!

XpfProject class
	instanceVariableNames: 'projects testProjects useTestData'!

!XpfProject class methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:10'!
addNewProject: aDictionary

	^ self addProject: (self newFrom: aDictionary)! !

!XpfProject class methodsFor: 'add-remove' stamp: 'mt 4/6/2009 14:25'!
addProject: aProject

	(self pvtProjects includes: aProject) ifTrue: [^ aProject].
	aProject id: self incrementId.
	^ self pvtProjects add: aProject! !

!XpfProject class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:24'!
all

	^ self projects! !

!XpfProject class methodsFor: 'accessing' stamp: 'SR 4/17/2009 08:40'!
allWithDeleted

	^ self projectsWithDeleted! !

!XpfProject class methodsFor: 'description' stamp: 'mt 4/16/2009 13:31'!
collectionPropertyNames

	^ super collectionPropertyNames, #(developers iterations)! !

!XpfProject class methodsFor: 'initialization' stamp: 'mig 4/17/2009 19:30'!
initialize

	super initialize.
	self
		useTestData: false;
		projects: Set new;
		testProjects: Set new.! !

!XpfProject class methodsFor: 'instance creation' stamp: 'SR 3/25/2009 18:08'!
newFrom: aDictionary

	^ self new title: (aDictionary at: 'title')! !

!XpfProject class methodsFor: 'description' stamp: 'topa 3/3/2009 22:26'!
primitivePropertyNames

	^ super primitivePropertyNames, #(title)! !

!XpfProject class methodsFor: 'accessing' stamp: 'mt 4/6/2009 15:36'!
projects

	^ (self useTestData
		ifTrue: [self testProjects]
		ifFalse: [self pvtProjects]) reject: [:project | project isDeleted]! !

!XpfProject class methodsFor: 'accessing' stamp: 'mt 4/6/2009 15:30'!
projects: aCollection

	self useTestData
		ifTrue: [self testProjects: aCollection]
		ifFalse: [projects := aCollection]! !

!XpfProject class methodsFor: 'accessing' stamp: 'SR 4/17/2009 08:40'!
projectsWithDeleted

	^ (self useTestData
		ifTrue: [self testProjects]
		ifFalse: [self pvtProjects])! !

!XpfProject class methodsFor: 'accessing' stamp: 'mt 4/6/2009 11:55'!
pvtProjects

	^ self useTestData
		ifTrue: [self testProjects]
		ifFalse: [projects]! !

!XpfProject class methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:46'!
testProjects

	^ testProjects! !

!XpfProject class methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:04'!
testProjects: anObject

	testProjects := anObject.! !

!XpfProject class methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:25'!
useTestData

	^ useTestData! !

!XpfProject class methodsFor: 'testing' stamp: 'topa 4/7/2009 14:04'!
useTestData: aBoolean

	useTestData := aBoolean.! !

!XpfProject methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:05'!
addDeveloper: aUser

	self pvtDevelopers 
		add: aUser
		ifPresent: [^ aUser].
	aUser addProject: self.
	self 
		historyAddEntry: #added
		for: #developers
		to: aUser.
	^ aUser! !

!XpfProject methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:05'!
addIteration: anIteration

	(anIteration isXpfFutureIteration or: [self pvtIterations includes: anIteration]) 
		ifTrue: [^ anIteration].
	self pvtIterations add: anIteration before: (self pvtIterations last).
	anIteration
		project: self;
		id: anIteration class incrementId.
	self historyAddEntry: #added for: #iterations to: anIteration.
	^ anIteration! !

!XpfProject methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:13'!
addNewIteration: aDictionary

	^ self addIteration: (XpfIteration newFrom: aDictionary)! !

!XpfProject methodsFor: 'deleting' stamp: 'mt 4/16/2009 11:36'!
delete
	
	self iterations do: [:iter | iter delete].
	super delete.! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:41'!
developers

	^ developers reject: [:dev | dev isDeleted]! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 5/6/2009 13:05'!
developersWithDeleted

	^ developers! !

!XpfProject methodsFor: 'initialization' stamp: 'mt 4/16/2009 11:08'!
initialize

	super initialize.
	self
		pvtIterations: (OrderedCollection with: (XpfFutureIteration new project: self));
		pvtDevelopers: OrderedCollection new.
! !

!XpfProject methodsFor: 'authorization' stamp: 'cs 3/18/2009 15:28'!
isMethod: aMethodString allowedFor: aUser

	^ self developers includes: aUser! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/6/2009 15:35'!
iterations

	^ self pvtIterations reject: [:it | it isDeleted]! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 5/6/2009 13:05'!
iterationsWithDeleted

	^ iterations! !

!XpfProject methodsFor: 'printing' stamp: 'mt 2/25/2009 10:16'!
printString

	^ self title ifNil: ['No Title']! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:41'!
pvtDevelopers

	^ developers! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/16/2009 10:41'!
pvtDevelopers: anObject

	developers := anObject.! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/6/2009 11:52'!
pvtIterations

	^ iterations! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/6/2009 15:23'!
pvtIterations: anObject

	iterations := anObject.! !

!XpfProject methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:05'!
removeDeveloper: aUser

	self pvtDevelopers 
		remove: aUser
		ifAbsent: [^ aUser].
	self 
		historyAddEntry: #removed
		for: #developers
		to: aUser.
	aUser removeProject: self.
	^ aUser! !

!XpfProject methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:24'!
title

	^ title! !

!XpfProject methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:26'!
title: anObject

	anObject = self title ifTrue: [^ self].
	self historyAddEntry: #changed for: #title from: self title to: anObject.
	title := anObject.! !

!XpfProject methodsFor: 'updating' stamp: 'mt 5/7/2009 10:27'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	^ 3 "Never."! !

XpfEntityWithHistory subclass: #XpfTask
	instanceVariableNames: 'title userStory timeEstimated timeActual developers isDone responsibleDeveloper isStarted lastStarted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfTask commentStamp: 'mt 2/12/2009 12:22' prior: 0!
I am a task in tems of Extreme Programming.!

!XpfTask class methodsFor: 'description' stamp: 'mt 4/15/2009 17:10'!
collectionPropertyNames

	^ super collectionPropertyNames, #(developers)! !

!XpfTask class methodsFor: 'instance creation' stamp: 'mt 4/15/2009 16:58'!
newFrom: aDictionary

	^ self new
		title: (aDictionary at: 'title' ifAbsent: []);
		timeActual: (aDictionary at: 'timeActual' ifAbsent: []);
		timeEstimated: (aDictionary at: 'timeEstimated' ifAbsent: []);
		isDone: (aDictionary at: 'isDone' ifAbsent: [false])! !

!XpfTask class methodsFor: 'description' stamp: 'cs 4/23/2009 13:49'!
primitivePropertyNames

	^ super primitivePropertyNames, #(title timeEstimated timeActual isDone isStarted)! !

!XpfTask class methodsFor: 'description' stamp: 'mt 4/16/2009 13:31'!
referencePropertyNames

	^ super referencePropertyNames, #(responsibleDeveloper userStory)! !

!XpfTask methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:05'!
addDeveloper: aUser

	self pvtDevelopers 
		add: aUser
		ifPresent: [^ aUser].
	aUser addTask: self.
	self 
		historyAddEntry: #added
		for: #developers
		to: aUser.
	^ aUser! !

!XpfTask methodsFor: 'deleting' stamp: 'mt 4/16/2009 12:56'!
delete

	self userStory historyAddEntry: #removed for: #tasks to: self.
	super delete.! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:19'!
developers

	^ developers reject: [:dev | dev isDeleted]! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 5/6/2009 13:05'!
developersWithDeleted

	^ developers! !

!XpfTask methodsFor: 'initialization' stamp: 'mt 4/16/2009 11:19'!
initialize

	super initialize.
	self pvtDevelopers: OrderedCollection new.! !

!XpfTask methodsFor: 'accessing' stamp: 'test 4/16/2009 13:36'!
isDone

	^ isDone ifNil: [isDone := false]! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 14:12'!
isDone: anObject

	anObject = self isDone ifTrue: [^ self].
	self isDone & self isStarted ifTrue: [self isStarted: false].
	self historyAddEntry: #changed for: #isDone from: self isDone to: anObject.
	isDone := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:41'!
isStarted

	^ isStarted ifNil: [isStarted := false]! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 14:08'!
isStarted: anObject

	anObject = self isStarted ifTrue: [^ self].
	(self isStarted not & anObject) ifTrue: [self startWork].
	(self isStarted & anObject not) ifTrue: [self stopWork].
	self historyAddEntry: #changed for: #isStarted from: self isStarted to: anObject.
	isStarted := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:49'!
lastStarted

	^ lastStarted! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 4/23/2009 13:49'!
lastStarted: anObject

	lastStarted := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:18'!
pvtDevelopers

	^ developers! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:18'!
pvtDevelopers: anObject

	developers := anObject.! !

!XpfTask methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:06'!
removeDeveloper: aUser

	self pvtDevelopers 
		remove: aUser
		ifAbsent: [^ aUser].
	self 
		historyAddEntry: #removed
		for: #developers
		to: aUser.
	aUser removeTask: self.
	^ aUser! !

!XpfTask methodsFor: 'accessing' stamp: 'SR 4/10/2009 15:07'!
responsibleDeveloper

	^ responsibleDeveloper! !

!XpfTask methodsFor: 'accessing' stamp: 'cs 5/20/2009 14:06'!
responsibleDeveloper: anObject

	anObject = self responsibleDeveloper ifTrue: [^ self].
	self 
		historyAddEntry: #changed
		for: #responsibleDeveloper
		from: self responsibleDeveloper
		to: anObject.
	responsibleDeveloper := anObject.
	self addDeveloper: anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 5/7/2009 22:22'!
startWork

	self timeActual ifNil: [self timeActual: 0].
	self lastStarted: DateAndTime now.! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 5/14/2009 14:08'!
stopWork

	| delta |
	delta := Timespan starting: self lastStarted ending: DateAndTime now.
	self timeActual: self timeActual + (delta duration asSeconds / 3600) asFloat.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
timeActual

	^ timeActual! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:26'!
timeActual: anObject

	anObject = self timeActual ifTrue: [^ self].
	self historyAddEntry: #changed for: #timeActual from: self timeActual to: anObject.
	timeActual := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
timeEstimated

	^ timeEstimated! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:27'!
timeEstimated: anObject

	anObject = self timeEstimated ifTrue: [^ self].
	self historyAddEntry: #changed for: #timeEstimated from: self timeEstimated to: anObject.
	timeEstimated := anObject.! !

!XpfTask methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:31'!
title

	^ title! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:27'!
title: anObject

	anObject = self title ifTrue: [^ self].
	self historyAddEntry: #changed for: #title from: self title to: anObject.
	title := anObject.! !

!XpfTask methodsFor: 'updating' stamp: 'mt 5/7/2009 10:28'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	^ 3! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/15/2009 16:59'!
userStory

	^ userStory! !

!XpfTask methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:27'!
userStory: anXpfUserStory

	self userStory = anXpfUserStory ifTrue: [^ anXpfUserStory].
	userStory := anXpfUserStory.
	self historyAddEntry: #changed for: #userStory from: self userStory to: anXpfUserStory.! !

XpfEntityWithHistory subclass: #XpfUser
	instanceVariableNames: 'userName email projects password tasks lastAccess sharingPort wasOnline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

XpfUser class
	instanceVariableNames: 'users adminUser testUsers useTestData'!

!XpfUser commentStamp: 'mt 2/12/2009 12:24' prior: 0!
I am a system or application user. This could be an administrator, webmaster, developer or something like that.!

XpfUser class
	instanceVariableNames: 'users adminUser testUsers useTestData'!

!XpfUser class methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:02'!
addNewUser: aDictionary

	^ self addUser: (self newFrom: aDictionary)! !

!XpfUser class methodsFor: 'add-remove' stamp: 'mt 4/6/2009 14:28'!
addUser: aUser

	(self pvtUsers includes: aUser) ifTrue: [^ aUser].
	aUser id: self incrementId.
	^ self pvtUsers add: aUser! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:47'!
adminUser

	^ adminUser! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:05'!
adminUser: anObject

	adminUser := anObject.! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:37'!
all

	^ self users! !

!XpfUser class methodsFor: 'accessing' stamp: 'SR 4/17/2009 08:39'!
allWithDeleted

	^ self usersWithDeleted! !

!XpfUser class methodsFor: 'authentication' stamp: 'mt 4/3/2009 11:02'!
authenticate: aLogin by: aPassword
	
	^ self all 
		detect: [ :aUser| (aUser login = aLogin) and: [aUser authenticateBy: aPassword]]
		ifNone: []! !

!XpfUser class methodsFor: 'description' stamp: 'topa 3/3/2009 22:37'!
collectionPropertyNames

	^ super collectionPropertyNames, #(tasks projects)! !

!XpfUser class methodsFor: 'authentication' stamp: 'SR 3/9/2009 15:46'!
findByLogin: aLoginString

	^ self all detect: [:user | user login = aLoginString]! !

!XpfUser class methodsFor: 'authentication' stamp: 'topa 3/3/2009 22:37'!
hash: aString

	^ SecureHashAlgorithm new hashMessage: aString! !

!XpfUser class methodsFor: 'initialization' stamp: 'topa 5/20/2009 15:15'!
initialize

	super initialize.
	self 
		useTestData: false;
		users: Set new;
		adminUser: (self addNewUser: (Dictionary newFrom: {
			'userName' -> 'Administrator'. 
			'login' -> 'admin@example.com'. 
			'password' -> 'nimda'}));
		testUsers: Set new.! !

!XpfUser class methodsFor: 'instance creation' stamp: 'SR 3/25/2009 18:01'!
newFrom: aDictionary

	^ self new
		userName: (aDictionary at: 'userName' ifAbsent: []);
		login: (aDictionary at: 'login');
		password: (aDictionary at: 'password' ifAbsent: [])! !

!XpfUser class methodsFor: 'default' stamp: 'topa 4/27/2009 14:07'!
onlineTimeout

	^ 10 seconds! !

!XpfUser class methodsFor: 'description' stamp: 'topa 4/27/2009 13:52'!
primitivePropertyNames

	^ super primitivePropertyNames, #(login userName email password isOnline sharingPort)! !

!XpfUser class methodsFor: 'accessing' stamp: 'mt 4/6/2009 11:56'!
pvtUsers 

	^ self useTestData
		ifTrue: [self testUsers]
		ifFalse: [users]! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:48'!
testUsers

	^ testUsers! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:06'!
testUsers: anObject

	testUsers := anObject.! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:48'!
useTestData

	^ useTestData! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:06'!
useTestData: anObject

	useTestData := anObject.! !

!XpfUser class methodsFor: 'accessing' stamp: 'mt 4/6/2009 15:36'!
users 

	^ (self useTestData
		ifTrue: [self testUsers]
		ifFalse: [self pvtUsers]) reject: [:user | user isDeleted]! !

!XpfUser class methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:06'!
users: aCollection

	self useTestData
		ifTrue: [self testUsers: aCollection]
		ifFalse: [users := aCollection].! !

!XpfUser class methodsFor: 'accessing' stamp: 'SR 4/17/2009 08:39'!
usersWithDeleted 

	^ (self useTestData
		ifTrue: [self testUsers]
		ifFalse: [self pvtUsers])! !

!XpfUser methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:07'!
addProject: aProject

	self pvtProjects 
		add: aProject
		ifPresent: [^ aProject].
	aProject addDeveloper: self.
	self 
		historyAddEntry: #added
		for: #projects
		to: aProject.
	^ aProject! !

!XpfUser methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:07'!
addTask: aTask

	self pvtTasks 
		add: aTask
		ifPresent: [^ aTask].
	aTask addDeveloper: self.
	self 
		historyAddEntry: #added
		for: #tasks
		to: aTask.
	^ aTask! !

!XpfUser methodsFor: 'authentication' stamp: 'SR 4/10/2009 12:18'!
authenticateBy: aString

	aString ifEmpty: [^ false]. "empty password is evil"
	^ self pvtPassword = (self class hash: aString)! !

!XpfUser methodsFor: 'deleting' stamp: 'mt 4/16/2009 13:16'!
delete

	self isAdmin ifTrue: [^ self].
	
	self projects do: [:project | 
		project historyAddEntry: #removed for: #developers to: self].
	self tasks do: [:task |
		task historyAddEntry: #removed for: #developers to: self].
	super delete.! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:33'!
email

	^ email! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:27'!
email: anObject

	anObject = self email ifTrue: [^ self].
	self historyAddEntry: #changed for: #email from: self email to: anObject.
	email := anObject.! !

!XpfUser methodsFor: 'initialization' stamp: 'topa 4/22/2009 13:34'!
initialize

	super initialize.
	self
		pvtProjects: OrderedCollection new;
		pvtTasks: OrderedCollection new.! !

!XpfUser methodsFor: 'authentication' stamp: 'mt 3/6/2009 13:08'!
isAdmin

	^ self = self class adminUser! !

!XpfUser methodsFor: 'testing' stamp: 'cs 4/29/2009 12:00'!
isMethod: aMethodString allowedFor: aUser

	^ aMethodString = 'PUT'
		ifTrue: [self = aUser or: [aUser isAdmin]]
		ifFalse: [true]
! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 4/27/2009 14:06'!
isOnline
	
	^ (TimeStamp now - self pvtLastAccess) <= self class onlineTimeout! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 4/27/2009 14:15'!
isOnline: anObject
	"this is not writable"

	^ self! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/27/2009 15:35'!
lastAccess: aTimeStamp
	
	lastAccess := aTimeStamp.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 3/4/2009 14:05'!
login

	^ email! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:27'!
login: anObject
	"You have to choose a valid email address as a login name."

	anObject = self email ifTrue: [^ self].
	self historyAddEntry: #changed for: #email from: self email to: anObject.
	email := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 4/7/2009 14:21'!
password
	"The password is never actually returned but compared to.
	This method is necessary for rest, too."
	
	^ nil! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:01'!
password: aString

	(aString notNil and: [(self class hash: aString) = password]) ifTrue: [^ self].
	self historyAddEntry: #changed for: #password.
	password := aString ifNotNil: [self class hash: aString].! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/15/2009 17:39'!
projects

	^ projects reject: [:project | project isDeleted]! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 5/6/2009 12:46'!
projectsWithDeleted

	^ projects! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 4/27/2009 14:24'!
pvtLastAccess

	^ lastAccess ifNil: [TimeStamp fromString: '1-1-2000 11:55:00 am'].! !

!XpfUser methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:35'!
pvtPassword

	^ password! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/15/2009 17:49'!
pvtProjects

	^ projects! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:25'!
pvtProjects: anObject

	projects := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:24'!
pvtTasks

	^ tasks! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 11:24'!
pvtTasks: anObject

	tasks := anObject.! !

!XpfUser methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:08'!
removeProject: aProject

	self pvtProjects 
		remove: aProject
		ifAbsent: [^ aProject].
	self 
		historyAddEntry: #removed
		for: #projects
		to: aProject.
	aProject removeDeveloper: self.
	^ aProject! !

!XpfUser methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:08'!
removeTask: aTask

	self pvtTasks 
		remove: aTask
		ifAbsent: [^ aTask].
	self 
		historyAddEntry: #removed
		for: #tasks
		to: aTask.
	aTask removeDeveloper: self.
	^ aTask! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/29/2009 14:32'!
revision

	self isOnline ~= self wasOnline ifTrue: [
		self wasOnline: self isOnline.
		self incrementRevision].
	^ super revision! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/27/2009 16:53'!
sharingPort

	self isOnline ifFalse: [self sharingPort: nil].
	^ sharingPort! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/29/2009 14:32'!
sharingPort: anObject

	anObject = sharingPort ifTrue: [^ self].
	
	self incrementRevision.
	sharingPort := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/15/2009 17:39'!
tasks

	^ tasks reject: [:task | task isDeleted]! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 5/6/2009 12:46'!
tasksWithDeleted

	^ tasks! !

!XpfUser methodsFor: 'updating' stamp: 'mt 5/7/2009 10:29'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	^ 1! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 3/4/2009 13:54'!
userName

	^ userName! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:28'!
userName: anObject

	self userName = anObject ifTrue: [^ self].
	self historyAddEntry: #changed for: #username from: self userName to: anObject.
	userName := anObject.! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/29/2009 14:35'!
wasOnline

	wasOnline ifNil: [wasOnline := false].
	^ wasOnline! !

!XpfUser methodsFor: 'accessing' stamp: 'mt 4/29/2009 14:33'!
wasOnline: anObject

	anObject = self wasOnline ifTrue: [^ self].
	
	wasOnline := anObject.
	self incrementRevision.! !

XpfEntityWithHistory subclass: #XpfUserStory
	instanceVariableNames: 'title priority timeEstimated tasks timeActual iteration positionX positionY color comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfUserStory commentStamp: 'topa 2/12/2009 14:06' prior: 0!
I am a user story in terms of Extreme Programming!

!XpfUserStory class methodsFor: 'description' stamp: 'topa 3/3/2009 22:40'!
collectionPropertyNames

	^ super collectionPropertyNames, #(tasks)! !

!XpfUserStory class methodsFor: 'instance creation' stamp: 'topa 4/30/2009 18:02'!
dictionaryClass

	^ Smalltalk at: #StringKeyValueDictionary ifAbsent: [Dictionary]! !

!XpfUserStory class methodsFor: 'instance creation' stamp: 'mt 4/15/2009 16:57'!
newFrom: aDictionary

	^ self new
		title: (aDictionary at: 'title' ifAbsent: []);
		priority: (aDictionary at: 'priority' ifAbsent: []);
		timeEstimated: (aDictionary at: 'timeEstimated' ifAbsent: []);
		timeActual: (aDictionary at: 'timeActual' ifAbsent: [])! !

!XpfUserStory class methodsFor: 'description' stamp: 'topa 4/30/2009 18:02'!
primitivePropertyNames

	^ super primitivePropertyNames, 
		#(title priority timeActual timeEstimated positionX positionY color comments)! !

!XpfUserStory class methodsFor: 'description' stamp: 'mt 4/16/2009 13:32'!
referencePropertyNames

	^ super referencePropertyNames, #(iteration)! !

!XpfUserStory methodsFor: 'add-remove' stamp: 'SR 3/25/2009 18:00'!
addNewTask: aPropertyDictionary

	^ self addTask: (XpfTask newFrom: aPropertyDictionary)! !

!XpfUserStory methodsFor: 'add-remove' stamp: 'cs 5/20/2009 14:09'!
addTask: aTask 

	| oldTaskRestUri |
	aTask id ifNil: [aTask id: aTask class incrementId].
	aTask userStory ifNotNil: 
		[oldTaskRestUri := aTask restUri.
		aTask userStory removeTask: aTask].
	aTask userStory: self.
	(self pvtTasks includes: aTask) ifFalse: 
		[self pvtTasks add: aTask.
		self 
			historyAddEntry: #added
			for: #tasks
			to: aTask.
		oldTaskRestUri ifNotNil: 
			[XpfRestResourceHttpHandler 
				redirectRestUriFrom: oldTaskRestUri
				to: aTask restUri]].
	^ aTask! !

!XpfUserStory methodsFor: 'accessing' stamp: 'SR 3/18/2009 15:25'!
color

	^ color! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:28'!
color: anObject

	anObject = self color ifTrue: [^ self].
	self historyAddEntry: #changed for: #color from: self color to: anObject.
	color := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 4/30/2009 17:58'!
comments

	^ comments ifNil: [self comments: self class dictionaryClass new. comments]! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 4/30/2009 17:50'!
comments: anObject

	comments := anObject.! !

!XpfUserStory methodsFor: 'deleting' stamp: 'mt 4/16/2009 12:56'!
delete

	self tasks do: [:task | task delete].
	self iteration historyAddEntry: #removed for: #userStories to: self.
	super delete.! !

!XpfUserStory methodsFor: 'initialization' stamp: 'mt 5/6/2009 17:49'!
initialize

	super initialize.
	self 
		pvtTasks: OrderedCollection new;
		positionX: 0.0;
		positionY: 0.0;
		color: 'white'.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:40'!
iteration

	^ iteration! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:29'!
iteration: anObject

	self iteration = anObject ifTrue: [^ self].
	self historyAddEntry: #changed for: #iteration from: self iteration to: anObject.
	iteration := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:41'!
positionX

	^ positionX! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/6/2009 17:03'!
positionX: anObject

	anObject = positionX ifTrue: [^ self].
	self incrementRevision.
	positionX := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/24/2009 17:41'!
positionY

	^ positionY! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/6/2009 17:04'!
positionY: anObject

	anObject = positionY ifTrue: [^ self].
	self incrementRevision.
	positionY := anObject.! !

!XpfUserStory methodsFor: 'printing' stamp: 'mt 2/25/2009 10:21'!
printString

	^ self title ifNil: ['No Title']! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:39'!
priority

	^ priority! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:29'!
priority: anObject

	anObject = self priority ifTrue: [^ self].
	self historyAddEntry: #changed for: #priority from: self priority to: anObject.
	priority := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/15/2009 16:41'!
pvtTasks

	^ tasks! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/15/2009 16:53'!
pvtTasks: anObject

	tasks := anObject.! !

!XpfUserStory methodsFor: 'private' stamp: 'cs 5/20/2009 14:09'!
removeTask: aTask 

	(self tasks noneSatisfy: [:t | t = aTask]) ifTrue: [^ aTask].
	self pvtTasks remove: aTask.
	self 
		historyAddEntry: #removed
		for: #tasks
		to: aTask.
	aTask userStory: nil.
	^ aTask! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/15/2009 16:41'!
tasks

	^ self pvtTasks reject: [:task | task isDeleted]! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 5/6/2009 12:46'!
tasksWithDeleted

	^ tasks! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
timeActual

	^ timeActual! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:29'!
timeActual: anObject

	anObject = self timeActual ifTrue: [^ self].
	self historyAddEntry: #changed for: #timeActual from: self timeActual to: anObject.
	timeActual := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
timeEstimated

	^ timeEstimated! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:29'!
timeEstimated: anObject

	anObject = self timeEstimated ifTrue: [^ self].
	self historyAddEntry: #changed for: #timeEstimated from: self timeEstimated to: anObject.
	timeEstimated := anObject.! !

!XpfUserStory methodsFor: 'accessing' stamp: 'topa 3/3/2009 22:40'!
title

	^ title! !

!XpfUserStory methodsFor: 'accessing' stamp: 'mt 4/16/2009 13:29'!
title: anObject

	anObject = self title ifTrue: [^ self].
	self historyAddEntry: #changed for: #title from: self title to: anObject.
	title := anObject.! !

!XpfUserStory methodsFor: 'updating' stamp: 'mt 5/7/2009 10:29'!
updateInterval
	"Tell the client how often a changes request for this entity should be sent."
	
	^ 2! !

XpfEntity subclass: #XpfHistoryEntry
	instanceVariableNames: 'entity timestamp user action property oldVal newVal oldRef newRef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Models'!

!XpfHistoryEntry class methodsFor: 'as yet unclassified' stamp: 'cs 4/17/2009 12:04'!
entity: entity action: action property: property from: from to: to

	^ self new
		entity: entity;
		action: action;
		property: property;
		old: from;
		new: to! !

!XpfHistoryEntry class methodsFor: 'description' stamp: 'cs 4/17/2009 11:57'!
primitivePropertyNames

	^ super primitivePropertyNames, #(timestamp action property oldVal newVal)! !

!XpfHistoryEntry class methodsFor: 'description' stamp: 'cs 4/17/2009 12:03'!
referencePropertyNames

	^ super referencePropertyNames, #(entity user oldRef newRef)! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:44'!
action

	^ action! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:44'!
action: anObject

	action := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 12:01'!
entity

	^ entity! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 12:01'!
entity: anObject

	entity := anObject.! !

!XpfHistoryEntry methodsFor: 'as yet unclassified' stamp: 'topa 5/20/2009 16:32'!
initialize

	super initialize.
	self
		id: self class incrementId;
		timestamp: TimeStamp now printString;
		user: XpfCurrentUser value.! !

!XpfHistoryEntry methodsFor: 'as yet unclassified' stamp: 'cs 4/17/2009 13:04'!
isMethod: aMethodString allowedFor: aUser
	"returns whether the method is allowed for the specified user; may be overwritten in subclasses"

	^ self entity isMethod: aMethodString allowedFor: aUser! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:52'!
new: anObject

	anObject isXpfEntity
		ifTrue: [self newRef: anObject]
		ifFalse: [self newVal: anObject].! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:44'!
newRef

	^ newRef.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:44'!
newRef: anObject

	newRef := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
newVal

	^ newVal! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
newVal: anObject

	newVal := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:51'!
old: anObject

	anObject isXpfEntity
		ifTrue: [self oldRef: anObject]
		ifFalse: [self oldVal: anObject].! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
oldRef

	^ oldRef! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
oldRef: anObject

	oldRef := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
oldVal

	^ oldVal! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
oldVal: anObject

	oldVal := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
property

	^ property! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
property: anObject

	property := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
timestamp

	^ timestamp! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:45'!
timestamp: anObject

	timestamp := anObject.! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:46'!
user

	^ user! !

!XpfHistoryEntry methodsFor: 'accessing' stamp: 'cs 4/17/2009 11:46'!
user: anObject

	user := anObject.! !

AnObsoleteRestDynamicVariable subclass: #XpfCurrentUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Server-Rest'!
XpfRfbTunnelHttpHandler initialize!
XpfProject initialize!
XpfUser initialize!
